Disk ARchive: libdar::cache Class Reference

| Disk ARchive 2.8.3 Full featured and portable backup and archiving tool

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | Private Member Functions | Private Attributes | List of all members
libdar::cache Class Reference
Private

the cache class implements a fixed length read/write caching mechanism More...

`#include <cache.hpp>`

Inherits libdar::generic_file.

## Public Member Functions
| cache (generic_file &hidden, bool shift_mode, U_I size=102400)
| cache (const cache &ref)=delete
| cache (cache &&ref)=delete
cache & | operator= (const cache &ref)=delete
cache & | operator= (cache &&ref)=delete
void | change_to_read_write ()
virtual bool | skippable (skippability direction, const infinint &amount) override
| whether the implementation is able to skip
virtual bool | skip (const infinint &pos) override
| skip at the absolute position
virtual bool | skip_to_eof () override
| skip to the end of file
virtual bool | skip_relative (S_I x) override
| skip relatively to the current position
virtual bool | truncatable (const infinint &pos) const override
| whether the implementation is able to truncate to the given position
virtual infinint | get_position () const override
| get the current read/write position
Public Member Functions inherited from libdar::generic_file
| generic_file (gf_mode m)
| main constructor
| generic_file (const generic_file &ref)
| copy constructor
| generic_file (generic_file &&ref) noexcept
| move constructor
generic_file & | operator= (const generic_file &ref)
| assignment operator
generic_file & | operator= (generic_file &&ref) noexcept
| move operator
| ~generic_file () noexcept(false)
| virtual destructor,
void | terminate ()
| destructor-like call, except that it is allowed to throw exceptions
bool | operator== (generic_file &ref)
bool | operator!= (generic_file &ref)
gf_mode | get_mode () const
| retreive the openning mode for this object
void | read_ahead (const infinint &amount)
void | ignore_read_ahead (bool mode)
virtual U_I | read (char *a, U_I size) override
| read data from the generic_file inherited from proto_generic_file
virtual void | write (const char *a, U_I size) override
| write data to the generic_file inherited from proto_generic_file
void | write (const std::string &arg)
| write a string to the generic_file
S_I | read_back (char &a)
| skip back one char, read on char and skip back one char
S_I | read_forward (char &a)
| read one char
virtual void | truncate (const infinint &pos)
| truncate file at the given offset
virtual void | copy_to (generic_file &ref)
| copy all data from current position to the object in argument
virtual void | copy_to (generic_file &ref, const infinint &crc_size, crc *&value)
| copy all data from the current position to the object in argument and computes a CRC value of the transmitted data
U_32 | copy_to (generic_file &ref, U_32 size)
| small copy (up to 4GB) with CRC calculation
infinint | copy_to (generic_file &ref, infinint size)
| copy the given amount to the object in argument
bool | diff (generic_file &f, const infinint &me_read_ahead, const infinint &you_read_ahead, const infinint &crc_size, crc *&value)
| compares the contents with the object in argument
bool | diff (generic_file &f, const infinint &me_read_ahead, const infinint &you_read_ahead, const infinint &crc_size, crc *&value, infinint &err_offset)
void | reset_crc (const infinint &width)
| reset CRC on read or writen data
bool | crc_status () const
| to known whether CRC calculation is activated or not
crc * | get_crc ()
| get CRC of the transfered date since last reset
void | sync_write ()
| write any pending data
void | flush_read ()
| be ready to read at current position, reseting all pending data for reading, cached and in compression engine for example
Public Member Functions inherited from libdar::proto_generic_file
| proto_generic_file (const proto_generic_file &ref)=default
| copy constructor
| proto_generic_file (proto_generic_file &&ref) noexcept=default
| move constructor
proto_generic_file & | operator= (const proto_generic_file &ref)=default
| assignment operator
proto_generic_file & | operator= (proto_generic_file &&ref) noexcept=default
| move operator
virtual | ~proto_generic_file () noexcept(false)
| virtual destructor

## Protected Member Functions
virtual void | inherited_read_ahead (const infinint &amount) override
| tells the object that several calls to read() will follow to probably obtain at least the given amount of data
virtual U_I | inherited_read (char *a, U_I size) override
| implementation of read() operation
virtual void | inherited_write (const char *a, U_I size) override
| implementation of the write() operation
virtual void | inherited_truncate (const infinint &pos) override
| truncate file at the give offset
virtual void | inherited_sync_write () override
| write down any pending data
virtual void | inherited_flush_read () override
| reset internal engine, flush caches in order to read the data at current position
virtual void | inherited_terminate () override
| destructor-like call, except that it is allowed to throw exceptions
Protected Member Functions inherited from libdar::generic_file
void | set_mode (gf_mode x)
bool | is_terminated () const

## Private Member Functions
bool | need_flush_write () const
void | alloc_buffer (size_t x_size)
| allocate x_size byte in buffer field and set size accordingly
void | release_buffer ()
| release memory set buffer to nullptr and size to zero
void | shift_by_half ()
void | clear_buffer ()
void | flush_write ()
void | fulfill_read ()
U_I | available_in_cache (skippability direction) const

## Private Attributes
generic_file * | ref
| underlying file, (not owned by "this', not to be delete by "this")
char * | buffer
| data in transit
U_I | size
| allocated size
U_I | half
| precalculated half = size / 2
U_I | next
| next to read or next place to write to
U_I | last
| first byte of invalid data in the cache. we have: next <= last < size
U_I | first_to_write
| position of the first byte that need to be written. if greater than last, no byte need writing
infinint | buffer_offset
| position of the first byte in buffer
bool | shifted_mode
| whether to half flush and shift or totally flush data
infinint | eof_offset
| size of the underlying file (read-only mode), set to zero if unknown

## Additional Inherited Members
Public Types inherited from libdar::generic_file
enum | skippability { skip_backward , skip_forward }

## Detailed Description

the cache class implements a fixed length read/write caching mechanism

it is intended to reduce context switches when no compression is used and when reading or writing catalogue through a pipe. The catalogue read and write is done by calling dump/constructor methods of the many objects that a catalogue contains. This makes a lot of small reads or writes, which make very poor performances when used over the network through a pipe to ssh. When compression is used, the problem disapears as the compression engine gather these many small reads or writes into much bigger ones. This in only when there is no compression or encryption that this class is useful (and used). Another target of class cache is to provide limited skippability when data is read of written to pipe (which do not have any skippability)

Definition at line 52 of file cache.hpp.

## Constructor & Destructor Documentation

## ◆ cache()

libdar::cache::cache | ( | generic_file & | hidden,
|  | bool | shift_mode,
|  | U_I | size = 102400 )

Parameters

  hidden | is the file to cache, it is never deleted by the cache object,
  shift_mode | if true, when all cached data has been read, half of the data is flushed from the cache, the other half is shifted and new data take place to fill the cache. This is necessary for sequential reading, but has some CPU overhead.
  size | is the (fixed) size of the cache

References cache(), libdar::generic_file::generic_file(), libdar::gf_read_only, libdar::gf_read_write, ref, and size.

Referenced by cache().

## Member Function Documentation

## ◆ change_to_read_write()

void libdar::cache::change_to_read_write | ( |  | ) |
| inline

Definition at line 64 of file cache.hpp.

## ◆ get_position()

virtual infinint libdar::cache::get_position | ( |  | ) | const
| inlineoverridevirtual

get the current read/write position

Implements libdar::generic_file.

Definition at line 73 of file cache.hpp.

References buffer_offset, and next.

## ◆ inherited_flush_read()

virtual void libdar::cache::inherited_flush_read | ( |  | ) |
| inlineoverrideprotectedvirtual

reset internal engine, flush caches in order to read the data at current position

Note
  when the object relies on external object or system object to fetch the data from for reading, when a call to (inherited_)flush_read() occurs, the current object must not assume that any previously read data is still valid if it has internal buffers or the like and it should flush them asap. This call must not propagate the flush_read to any other gneric_file object it could rely on

Implements libdar::generic_file.

Definition at line 82 of file cache.hpp.

## ◆ inherited_read()

virtual U_I libdar::cache::inherited_read | ( | char * | a,
|  | U_I | size )
| overrideprotectedvirtual

implementation of read() operation

Parameters

  [in,out] | a | where to put the data to read
  [in] | size | says how much data to read

Returns
  the exact amount of data read and put into 'a'

Note
  read as much byte as requested, up to end of file stays blocked if not enough data is available and EOF not yet met. May return less data than requested only if EOF as been reached. in other worlds, EOF is reached when returned data is stricly less than the requested data Any problem shall be reported by throwing an exception.

Implements libdar::generic_file.

References size.

## ◆ inherited_read_ahead()

virtual void libdar::cache::inherited_read_ahead | ( | const infinint & | amount | ) |
| overrideprotectedvirtual

tells the object that several calls to read() will follow to probably obtain at least the given amount of data

Parameters

  [in] | amount | is the maximum expected amount of data that is known to be read

Note
  this call may be implemented as a do-nothing call, its presence is only to allow optimization when possible, like in multi-threaded environment

Implements libdar::generic_file.

## ◆ inherited_sync_write()

virtual void libdar::cache::inherited_sync_write | ( |  | ) |
| inlineoverrideprotectedvirtual

write down any pending data

Note
  called after sanity checks from generic_file::sync_write() this method's role is to write down any data pending for writing in the current object it has not to be propagated to other gneric_file object this object could rely on

Implements libdar::generic_file.

Definition at line 81 of file cache.hpp.

## ◆ inherited_terminate()

virtual void libdar::cache::inherited_terminate | ( |  | ) |
| inlineoverrideprotectedvirtual

destructor-like call, except that it is allowed to throw exceptions

Note
  this method must never be called directly but using terminate() instead, generic_file class manages it to never be called more than once

Implements libdar::generic_file.

Definition at line 83 of file cache.hpp.

## ◆ inherited_truncate()

virtual void libdar::cache::inherited_truncate | ( | const infinint & | pos | ) |
| overrideprotectedvirtual

truncate file at the give offset

Note
  if pos is greater than the current file size, this call may do nothing (not even enlarging the file)
  this call should always fail on a read-only generic_file
  implementation must throw exception if truncate is not possible for other reason than read/write access mode

Implements libdar::generic_file.

## ◆ inherited_write()

virtual void libdar::cache::inherited_write | ( | const char * | a,
|  | U_I | size )
| overrideprotectedvirtual

implementation of the write() operation

Parameters

  [in] | a | what data to write
  [in] | size | amount of data to write

Note
  must either write all data or report an error by throwing an exception

Implements libdar::generic_file.

References size.

## ◆ need_flush_write()

bool libdar::cache::need_flush_write | ( |  | ) | const
| inlineprivate

Definition at line 97 of file cache.hpp.

## ◆ skip()

virtual bool libdar::cache::skip | ( | const infinint & | pos | ) |
| overridevirtual

skip at the absolute position

Parameters

  [in] | pos | the offset in byte where next read/write operation must start

Returns
  true if operation was successfull and false if the requested position is not valid (after end of file)

Note
  if requested position is not valid the reading/writing cursor must be set to the closest valid position

Implements libdar::generic_file.

## ◆ skip_relative()

virtual bool libdar::cache::skip_relative | ( | S_I | x | ) |
| overridevirtual

skip relatively to the current position

Implements libdar::generic_file.

## ◆ skip_to_eof()

virtual bool libdar::cache::skip_to_eof | ( |  | ) |
| overridevirtual

skip to the end of file

Implements libdar::generic_file.

## ◆ skippable()

virtual bool libdar::cache::skippable | ( | skippability | direction,
|  | const infinint & | amount )
| overridevirtual

whether the implementation is able to skip

Note
  the capability to skip does not mean that skip_relative() or skip() will succeed, but rather that the inherited class implementation does not by construction forbid the requested skip (like inherited class providing a generic_file interface of an anonymous pipe for example)

Implements libdar::generic_file.

## ◆ truncatable()

virtual bool libdar::cache::truncatable | ( | const infinint & | pos | ) | const
| overridevirtual

whether the implementation is able to truncate to the given position

Implements libdar::generic_file.

## Member Data Documentation

## ◆ buffer

char* libdar::cache::buffer
| private

data in transit

Definition at line 87 of file cache.hpp.

## ◆ buffer_offset

infinint libdar::cache::buffer_offset
| private

position of the first byte in buffer

Definition at line 93 of file cache.hpp.

Referenced by get_position().

## ◆ eof_offset

infinint libdar::cache::eof_offset
| private

size of the underlying file (read-only mode), set to zero if unknown

Definition at line 95 of file cache.hpp.

## ◆ first_to_write

U_I libdar::cache::first_to_write
| private

position of the first byte that need to be written. if greater than last, no byte need writing

Definition at line 92 of file cache.hpp.

## ◆ half

U_I libdar::cache::half
| private

precalculated half = size / 2

Definition at line 89 of file cache.hpp.

## ◆ last

U_I libdar::cache::last
| private

first byte of invalid data in the cache. we have: next <= last < size

Definition at line 91 of file cache.hpp.

## ◆ next

U_I libdar::cache::next
| private

next to read or next place to write to

Definition at line 90 of file cache.hpp.

Referenced by get_position().

## ◆ ref

generic_file* libdar::cache::ref
| private

underlying file, (not owned by "this', not to be delete by "this")

Definition at line 86 of file cache.hpp.

Referenced by cache().

## ◆ shifted_mode

bool libdar::cache::shifted_mode
| private

whether to half flush and shift or totally flush data

Definition at line 94 of file cache.hpp.

## ◆ size

U_I libdar::cache::size
| private

allocated size

Definition at line 88 of file cache.hpp.

Referenced by cache(), inherited_read(), and inherited_write().

The documentation for this class was generated from the following file:

- cache.hpp